/// Tlist
/// The Tlist is a doubly linked list with a number of que-like utility
/// functions.  The naming conventions were primarily inspired by the
/// c++ STL Standard Containers, but my implementation is strictly c.

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define NEW(type) ((type*)malloc(sizeof(type)))

/// Private Data.  Do not access this directly.  Utility functions
/// should be used to access and change the Tlist.

typedef struct Tlist_element_struct {
   void * data;
   struct Tlist_element_struct *next;
   struct Tlist_element_struct *previous;
} Tlist_element;

typedef struct Tlist_struct {
   Tlist_element *head;
   Tlist_element *tail;
   Tlist_element *current;
   int count;
} Tlist;

/// Public Functions.

Tlist*  Tlist_new ();
void    Tlist_delete (Tlist * list);
void    Tlist_delete_all (Tlist * list);
int     Tlist_count (Tlist * list);
void    Tlist_push_back (Tlist * list, void * data);
void    Tlist_push_front (Tlist * list, void * data);
void*   Tlist_next (Tlist * list);
void*   Tlist_next_until_tail (Tlist * list);
void*   Tlist_previous (Tlist * list);
void*   Tlist_previous_until_head (Tlist * list);
void*   Tlist_current (Tlist * list);
void*   Tlist_at (Tlist * list, int i);
void*   Tlist_head (Tlist * list);
void*   Tlist_tail (Tlist * list);
void    Tlist_virtual (Tlist * lista, Tlist * listb);
